Error when saving edited layer from Spatialite database
2016-07-03 03:38 AM - Michal Jurewicz

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/SpatialLite

Affected QGIS version:master Regression?: No

Operating System: OS X Easy fix?: No

Pull Request or Patch supplied: Resolution: not reproducable
Crashes QGIS or corrupls data: Copied to github as #: 23136
Description

| use master version QGIS 2.15 6000ff4f and there is very serious error during editing vector layers from Spatialite database. It's
impossible to save changes in layers. There is error like that:

Nie mozna zatwierdzi¢ zmian dla warstwy mala architektura i oznaczenia v6

Btedy: BLAD: nie dodano 1 obiektu.
Btedy zrodta danych:
Btad SQLite: tymczas.Geometry violates Geometry constraint [geom-type or SRID not allowed]
SQL: INSERT INTO "mala architektura i oznaczenia v6"("geometry","rodzaj") VALUES (ST_Multi(GeomFromWKB(?, 2180)),?)

Sorry that this is in Polish. Which is strange error occurs only sometimes, without any noticeable patterns or cause, at least for me. Which
is strange in the same time | can save edited layer as SHP or CSV without any problem. | can also import this SHP to database without
any errors. But it is very time consuming.

History

#1 - 2016-07-03 05:14 AM - R. R.
- File 15197.mp4 added

Hi Michal, this sounds like you are trying to save an invalid geometry (see screencast).

#2 - 2016-07-03 05:27 AM - Michal Jurewicz

| can't open your file. Please upload it one more time.

#3 - 2016-07-03 05:40 AM - R. R.

Just create a new SpatialL.ite table (Geometry: LineString) and add crossing line features. Next, select the features and merge them. Saving the layer edits
fails with a similar error like posted above.

#4 - 2016-07-03 05:53 AM - Matthias Kuhn
- Status changed from Open to Feedback

Hi Michal,
please also check the output of
SELECT *

FROM geometry_columns
WHERE f_table_name LIKE 'mala architektura i oznaczenia v6';

#5 - 2016-07-03 06:18 AM - Michal Jurewicz

OK, I understand. However, In my case | just add new point feature to points layer (with standard tool from QGIS). Nothing more, and this error suddenly
occurs.

#6 - 2016-07-03 06:27 AM - Michal Jurewicz

Here is screencast with corrupted layer: http://quick.as/56AlhimYe

| tried to add new point and save, without success. After deleting added points | saved with success.

#7 - 2016-07-03 07:21 AM - Giovanni Manghi

- Category set to Data Provider/Spatial.ite

- Priority changed from High to Normal

- Crashes QGIS or corrupts data changed from Yes to No

Could you please attach sample data? Thanks!

ps

it seems to me there is no data corruption, the original data is not lost or changed in any form, the issue is just about saving new data.

#8 - 2017-01-03 06:41 AM - Giovanni Manghi

Reinhard Reiterer wrote:
Just create a new Spatial.ite table (Geometry: LineString) and add crossing line features. Next, select the features and merge them. Saving the layer
edits fails with a similar error like posted above.

if the layer is declared as "lines" (and not "multilines") then is normal that trying create a multigeometry will fail.

#9 - 2017-01-03 06:46 AM - Giovanni Manghi
- Resolution set to not reproducable
- Status changed from Feedback to Closed

Giovanni Manghi wrote:

Could you please attach sample data? Thanks!
http://quick.as/56Alh1mYe

cannot replicate with data of my own on 2.18.2. Please reopen if necessary.
